from utils.mysql_helper import MySQLHelper


class AreaEmail:

    def __init__(self, name=None, area=None, email=None):
        self.name = name
        self.area = area
        if email is None:
            email = ""
        self.email = email.replace("，", ",")

    def __repr__(self):
        return (
            f"<AreaEmail(name={self.name},area={self.area}, email={self.email}, "
            f"is_active={self.is_active}, remark={self.remark})>")

    def to_dict(self):
        return {
            'area': self.area,
            'email': self.email,
        }

    # # 插入 AreaEmail 数据
    # def insert(self, area_email):
    #     if not isinstance(area_email, AreaEmail):
    #         raise TypeError("area_email 必须是 AreaEmail 的实例")
    #     with MySQLHelper() as db_helper:
    #         query = (
    #             "INSERT INTO t_area_email (area, email, is_active, remark) "
    #             "VALUES (%s, %s, %s, %s)")
    #         params = (area_email.area, area_email.email, area_email.is_active,
    #                   area_email.remark)
    #         db_helper.execute_non_query(query, params)

    # 查询 AreaEmail 数据
    def fetch_all(self):
        with MySQLHelper() as db_helper:
            query = "SELECT name,area,email FROM t_area_email WHERE is_active = 1"
            results = db_helper.execute_query(query)
            data = [AreaEmail(**result) for result in results]
            return data

    def fetch_one_by_area(self, area: str):
        with MySQLHelper() as db_helper:
            query = "SELECT email FROM t_area_email WHERE CONCAT(area,',') like %s AND is_active = 1"
            params = ('%' + area + ',%', )
            result = db_helper.fetch_one(query, params)
            if result is None:
                return None
            return result["email"]
